//+------------------------------------------------------------------+
//|                                       TrendStrengthExpert_v2.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
// #property copyright "Copyright  2007, TrendLaboratory Ltd."
// #property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

//
//
//
//
//

#include <stdlib.mqh>

//---- input parameters
//
//
//
//

extern string Expert_Name      = "Jurik_TrendStrength_v2.5";
extern bool   NoHedge          = false;
extern bool   StrictNoHedge    = false;
extern string SymbolsPrefix    = "";
extern string SymbolsSuffix    = "";
extern bool   UseAutoMagic     = true;
extern int    ManualMagic      = 123123123; 
extern bool   ECNbroker        = true;
extern int    Slippage         =  3;

extern string Main_data        = "Trade Volume & Trade Method";
extern double Lots             = 0.1;      // Trade Volume 
extern int    MaxOrders        = 1;
extern double TakeProfit       = 0;        // Take Profit Value in pips 
extern double StopLoss         = 0;        // Initial Stop Value in pips
extern int    TrailingStop     = 30;
extern int    MinimumProfit    = 20;          // minimum in profit before trailing stop starts
extern double MoneyRisk        = 1;        // Deviation of VoltyChannel_Stop or MoneyRisk
extern double BreakEven        = 0;        // Break-Even Value in pips
extern double ProfitLock       = 0;        // Profit Lock in pips
extern int    ExitMode         = 0;        // System Exit Switch:0-off,1-TS,2-TE,3-AddSignal,4-any first,5-signal
extern bool   SignalMail       = False;    // E-mail Alert Switch

extern string Time_Inputs      = "Timing parameters ";
extern int    TradeDay         = -1;       // Trade Day of Week (ex.1-Monday,-1-all Days) 
extern int    NonTradeDay      = 0;        // Non Trade Day of Week
extern int    StartHour        = 0;        // Start Hour of Trade Session 
extern int    StartMinute      = 0;        // Start Minute of Trade Session 
extern int    EndHour          = 23;       // End Hour of Trade Session
extern int    EndMinute        = 0;        // End Hour of Trade Session
extern int    MonStartHour     = 8;        // Monday Start Hour of Trade Session 
extern int    MonStartMinute   = 0;        // Monday Start Minute of Trade Session
extern int    FriEndHour       = 18;       // Friday End Hour of Trade Session
extern int    FriEndMinute     = 0;        // Friday End Hour of Trade Session 
extern int    CloseTimeMode    = 0;        // CloseTime mode: 0-off,1-on
extern int    CloseHour        = 24;       // Trade Close Hour   
extern int    CloseMinute      = 0;        // Trade Close Minute 
extern int    FriCloseHour     = 20;       // Trade Close Hour in Friday   
extern int    FriCloseMinute   = 55;       // Trade Close Minute in Friday 
extern double ProcessTime      = 3;  

extern string TE_Inputs        = "JurikTrendEnvelope parameters";
extern int    TE_TimeFrame     = 30;        // Time Frame in min
extern int    TE_Length        = 14;
extern double TE_Phase         = 0;
extern bool   TE_Double        = false;
extern int    TE_UpperPrice    = PRICE_CLOSE;
extern int    TE_LowerPrice    = PRICE_CLOSE;
extern double TE_Deviation     = 0.2;
extern int    TE_CurBar        = 1;        // Shift relative to the current bar
extern int    TE_Mode          = 0;        // TE Mode: 0-off,1-trend(confirmation),2-signal

extern string VS_Inputs        = "VoltyChannel_Stop parameters";
extern int    VS_TimeFrame     = 0;        // Time Frame in min
extern int    VS_Price         = 0;
extern double VS_SmoothLength  = 10;
extern double VS_SmoothPhase   = 0;
extern bool   VS_SmoothDouble  = true;
extern int    VS_ATRLength     = 10; 
extern double VS_Kv            = 4;  
extern double VS_MoneyRisk     = 1; 
extern int    VS_CurBar        = 1;        // Shift relative to the current bar
extern int    VS_Mode          = 0;        // VS Mode: 0-off,1-trend(confirmation),2-signal

extern string TS_Inputs        = "Jurik TrendStrength parameters";
extern int    TS_TimeFrame     =  0;       // Time Frame in min
extern int    TS_RsxLength     = 14;
extern int    TS_SmoothLength  = 1;
extern double TS_SmoothPhase   = 0;
extern bool   TS_SmoothDouble  = true;
extern int    TS_Price         = 8;
extern double TS_Kv            = 4.236;    // Multiplier 
extern int    TS_CurBar        = 1;        // Shift relative to the current bar
extern int    TS_Mode          = 1;        // TS Mode: 0-off,1-trend(confirmation),2-signal

extern string Add_Inputs       = "Jurik AddSignal parameters";
extern int    Add_TimeFrame    = 0;        // Time Frame in min
extern string x                = "Jurik Settings";
extern int    Add_JurikPrice   = 8;
extern int    Add_Length       = 100;
extern int    Add_Phase        = 0;
extern bool   Add_Double       = false;
extern string xx               = "Jurik STC Settings";
extern int    Add_STCPeriod    = 10;
extern int    Add_StcPrice     = 8;
extern int    Add_FastMAPeriod = 23;
extern int    Add_FastMAPhase  = 0;
extern bool   Add_FastDouble   = false;
extern int    Add_SlowMAPeriod = 50;
extern int    Add_SlowMAPhase  = 0;
extern bool   Add_SlowDouble   = false;
extern int    Add_FilterMode   = 3;
extern string N_RSXPeriod      = "JRSX Settings";
extern int    Add_RsxLength    = 14;
extern int    Add_Price        = 8;
extern int    Add_SmoothLength = 2;
extern int    Add_SmoothPhase  = 0;
extern bool   Add_SmoothDouble = false;
extern int    Add_CurBar       = 1;         // Shift relative to the current bar
extern int    Add_Mode         = 0;         // Add Mode: 0-off,1-trend(confirmation),2-signal

extern string AS_Inputs        = "AbsoluteStrength parameters";
extern int    AS_TimeFrame     = 30;        // Time Frame in min
extern int    AS_MathMode      = 1;         // 0-RSI method; 1-Stoch method; 2-ADX method
extern int    AS_Length        = 10;        // Period of evaluation
extern int    AS_Smooth        = 5;         // Period of smoothing
extern int    AS_Signal        = 5;         // Period of Signal Line
extern int    AS_Price         = 0;         // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    AS_ModeMA        = 3;         // Mode of Moving Average
extern int    AS_CurBar        = 1;         // Shift relative to the current bar
extern int    AS_Mode          = 1;         // Add Mode: 0-off,1-trend(confirmation),2-signal

extern string MM_inputs        = " MoneyManagement by L.Williams ";
extern bool   MM               = false;     //  Switch
extern double MaxRisk          =  0.05;     // Risk Factor
extern double MaxLoss          =  1000;     // Maximum Loss by 1 Lot

//
//
//
//
//

string   s_symbol;

int      Magic;
int      OrderBar=0;
int      BEvent=0, TriesNum=5;

datetime CurrBar,PrevBar;

double   Lotsi;
double   UpLine,DnLine;
double   TStrend, pTStrend, VStrend, pVStrend, Addtrend, pAddtrend, TEtrend, pTEtrend;
double   Bulls, sBulls, Bears, sBears;
double   _Point = 1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//
//

int init()
{
   s_symbol = Symbol();
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic;
   
   //
   //
   //
   //
   //
               
   if (TE_TimeFrame  == 0)  TE_TimeFrame  = Period();
   if (TS_TimeFrame  == 0)  TS_TimeFrame  = Period();
   if (VS_TimeFrame  == 0)  VS_TimeFrame  = Period();
   if (Add_TimeFrame == 0)  Add_TimeFrame = Period();  
   if (AS_TimeFrame  == 0)  AS_TimeFrame  = Period(); 
   
   
return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
//
//

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
//
//

int start()
{
   
   if (Digits == 3 || Digits == 5) 
        _Point = 10;   
   else _Point = 1;  
   
   //
   //
   //
   //
   //
   
   if(iBars(Symbol(),VS_TimeFrame) < 100 || IsTradeAllowed()==false) return(0); 
   
   //
   //
   //
   //
   //
   
   if(BuyMarketCount(Symbol(), Magic) > 0 && TrailingStop > 0)
	{
		BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,Magic);
	}

   if(SellMarketCount(Symbol(),Magic) > 0 && TrailingStop > 0)
	{
		SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,Magic);
	}
   
   //
   //
   //
   //
   //
     
   if(AccountFreeMargin()< 1000 * MoneyManagement())
   {
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);  
   }
   
   //
   //
   //
   //
   //
   
   CurrBar = iTime(Symbol(),0,0);
   if (CurrBar != PrevBar)
   {
      
      //
      //
      //
      //
      //
      
      int Signal = TradeSignal();
           
      if(ScanTrades() > 0)
      {
         if(ExitMode == 1)
         {
         if (TStrend > 0 && pTStrend < 0) CloseOrder(2);
         if (TStrend < 0 && pTStrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 2)
         {
         if (TEtrend > 0 && pTEtrend < 0) CloseOrder(2);
         if (TEtrend < 0 && pTEtrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 3)
         {
         if (VStrend > 0 && pVStrend < 0) CloseOrder(2);
         if (VStrend < 0 && pVStrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 4)
         {
         if (Addtrend > 0 && pAddtrend < 0) CloseOrder(2);
         if (Addtrend < 0 && pAddtrend > 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 5)
         {
         if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0) || (TEtrend > 0 && pTEtrend < 0)) CloseOrder(2);
         if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0) || (TEtrend < 0 && pTEtrend > 0)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 6)
         {
         if (Signal > 0) CloseOrder(2);
         if (Signal < 0) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 7)
         {
         if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0)||(Bulls > sBulls && Bulls > Bears)) CloseOrder(2);
         if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0)||(Bears > sBears && Bulls < Bears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 8)
         {
         if ((Bulls > sBulls)||(Bears < sBears)) CloseOrder(2);
         if ((Bulls < sBulls)||(Bears > sBears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 9)
         {
         if ((TStrend > 0 && pTStrend < 0)||(Bulls > sBulls)) CloseOrder(2);
         if ((TStrend < 0 && pTStrend > 0)||(Bears > sBears)) CloseOrder(1);
         }
         
         //
         //
         //
         //
         //
         
         if(CloseTimeMode > 0)
         {
         datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
         if(DayOfWeek() == 5) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute);
         if(TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose + ProcessTime * 60) while(ScanTrades() > 0) CloseOrder(0); 
         }
         }
      
      //
      //
      //
      //
      //
      
      if(ScanTrades() < MaxOrders)
      {
      if (Signal > 0 && canOpen(OP_BUY))  BuyOrdOpen() ;
      if (Signal < 0 && canOpen(OP_SELL)) SellOrdOpen();
      }
   }
   
   //
   //
   //
   //
   //
   
   PrevBar = CurrBar;
   return(0);
}

//-----------------------------------------------------
// Function Scan Trades
//-----------------------------------------------------
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
} 
 
//-----------------------------------------------------
// Function TimeCondition
//-----------------------------------------------------
//
//

bool TimeCondition()
{
   bool result = false;
    
      if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
      {
         if(StartHour == 24) StartHour = 0; 
      
         datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
         double   Start        = StartHour + StartMinute/60.0;
         datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
         double   End          = EndHour + EndMinute/60.0; 
         
         //
         //
         //
         //
         //
         
         if(DayOfWeek() != 1 && DayOfWeek() != 5)
         {    
            if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);  
                
            else
            if (Start > End)result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
                                   
         }
         else
         if(DayOfWeek() == 1)
         {    
            if(MonStartHour > 0 || MonStartMinute > 0) 
            {
            datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
            double   MonStart        = MonStartHour + MonStartMinute/60.0;
            }
            else
            {
            MonSessionStart = StrToTime(0+":"+0); 
            MonStart        = 0;
            }
            
            //
            //
            //
            //
            //
                        
            if (Start < End)
            { 
              if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
                            else result = TimeCurrent() >= SessionStart    && TimeCurrent() < SessionEnd;
            }
            else
            if (Start > End)
            {
               result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd)|| (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59)); 
                     
            }
         }
         else
         if(DayOfWeek() == 5)
         {
            if(FriEndHour > 0 || FriEndMinute > 0)
            {
            datetime FriSessionEnd = StrToTime(FriEndHour+":"+FriEndMinute);
            double   FriEnd        = FriEndHour + FriEndMinute/60.0; 
            }
            else
            {
            FriSessionEnd = SessionEnd;
            FriEnd        = End; 
            }
            
            //
            //
            //
            //
            //
            
            if (Start < End)
            {
              if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
                            else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;                 
            }
            
            else
            if (Start > End)
               result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
                           
         }  
      }
   
   return(result);
}   

//-----------------------------------------------------
// Function TS_Trend
//-----------------------------------------------------
//
//

int TS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TStrend  = iCustom(Symbol(),TS_TimeFrame,"TrendStrength on jurik for ea","",0,TS_RsxLength,TS_SmoothLength,TS_SmoothPhase,TS_SmoothDouble,TS_Price,TS_Kv,3,TS_CurBar);
   pTStrend = iCustom(Symbol(),TS_TimeFrame,"TrendStrength on jurik for ea","",0,TS_RsxLength,TS_SmoothLength,TS_SmoothPhase,TS_SmoothDouble,TS_Price,TS_Kv,3,TS_CurBar);
   
   //
   //
   //
   //
   //
          
   if (mode == 1)
   {
   if (TStrend > 0) result =  mode;
   if (TStrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (TStrend > 0 && pTStrend < 0) result =  mode;  
   if (TStrend < 0 && pTStrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function TE_Trend
//-----------------------------------------------------
//
//

int TE_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TEtrend  = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea","",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar);
   pTEtrend = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea","",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar+1);
   
   //
   //
   //
   //
   // 
        
   if (mode == 1)
   {
   if (TEtrend > 0) result =  mode;
   if (TEtrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (TEtrend > 0 && pTEtrend < 0) result =  mode;  
   if (TEtrend < 0 && pTEtrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function VS_Trend
//-----------------------------------------------------
//
//

int VS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   VStrend  = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea","",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar);
   pVStrend = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea","",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar+1);
   
   //
   //
   //
   //
   //
          
   if (mode == 1)
   {
   if (VStrend > 0) result =  mode;
   if (VStrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (VStrend > 0 && pVStrend < 0) result =  mode;  
   if (VStrend < 0 && pVStrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}
//-----------------------------------------------------
// Function Add_Trend
//-----------------------------------------------------
//
//

int Add_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   Addtrend  = iCustom(Symbol(),Add_TimeFrame,"JurikAddSignal_v1a","",0,"",Add_Price,Add_Length,Add_Phase,Add_Double,"",
   Add_STCPeriod,Add_StcPrice,Add_FastMAPeriod,Add_FastMAPhase,Add_FastDouble,Add_SlowMAPeriod,Add_SlowMAPhase,
   Add_FilterMode,"",Add_RsxLength,Add_Price,Add_SmoothLength,Add_SmoothPhase,Add_SlowDouble,2,Add_CurBar);
   
   pAddtrend = iCustom(Symbol(),Add_TimeFrame,"JurikAddSignal_v1a","",0,"",Add_Price,Add_Length,Add_Phase,Add_Double,"",
   Add_STCPeriod,Add_StcPrice,Add_FastMAPeriod,Add_FastMAPhase,Add_FastDouble,Add_SlowMAPeriod,Add_SlowMAPhase,
   Add_FilterMode,"",Add_RsxLength,Add_Price,Add_SmoothLength,Add_SmoothPhase,Add_SlowDouble,2,Add_CurBar+1);
   
   //
   //
   //
   //
   //
      
   if (mode == 1)
   {
   if (Addtrend > 0) result =  mode;
   if (Addtrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (Addtrend > 0 && pAddtrend < 0) result =  mode;
   if (Addtrend < 0 && pAddtrend > 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//-----------------------------------------------------
// Function AbStrength
//-----------------------------------------------------
//
//

int AbStrength(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   Bulls  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,0,AS_CurBar);
   sBulls = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,2,AS_CurBar);
   
   Bears  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,1,AS_CurBar);
   sBears = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,3,AS_CurBar);
   
   //
   //
   //
   //
   //
   
   if (mode == 1)
   {
   if (Bulls > sBulls) result =  mode;
   if (Bears > sBears) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
   if (Bulls > sBulls && Bulls > Bears) result =  mode;
   if (Bears > sBears && Bulls < Bears) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//-----------------------------------------------------
// Function TradeSignal
//-----------------------------------------------------
//
//

int TradeSignal()
{   
   int Signal = 0;
   
   //
   //
   //
   //
   //
   
   if (TS_Mode > 0 || ExitMode == 1 || ExitMode == 5 || ExitMode == 7 || ExitMode == 9) int TS = TS_Trend(TS_Mode);   else TS=0;
   if (TE_Mode > 0 || ExitMode == 2 || ExitMode == 5)                                   int TE = TE_Trend(TE_Mode);   else TE=0;
   if (VS_Mode > 0 || ExitMode == 3 || ExitMode == 5 || ExitMode == 7)                  int VS = VS_Trend(VS_Mode);   else VS=0; 
   if (Add_Mode> 0 || ExitMode == 4)                                                    int AD = Add_Trend(Add_Mode); else AD=0; 
   if (AS_Mode > 0 || ExitMode  > 6)                                                    int AS = AbStrength(AS_Mode); else AS=0;    
   
   //
   //
   //
   //
   //
   
   if (TimeCondition())
   {
   if (TE ==  TE_Mode && VS ==  VS_Mode && TS ==  TS_Mode && AD ==  Add_Mode && AS ==  AS_Mode) Signal = 1;
   if (TE == -TE_Mode && VS == -VS_Mode && TS == -TS_Mode && AD == -Add_Mode && AS == -AS_Mode) Signal =-1;
   }  
 
   return(Signal);
}

//-----------------------------------------------------
// Function MoneyManagement (Williams)
//-----------------------------------------------------
//
//

double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //--- basic formula
   //
   //
   //
   //
   
   if (MM)
   {
      if (MaxLoss > 0) vol = NormalizeDouble(AccountFreeMargin() * MaxRisk / MaxLoss,2);
      else   
      vol=NormalizeDouble(AccountFreeMargin() * MaxRisk * AccountLeverage() / contract,2);
   }
   else
   vol = Lots;
   
   //--- check min, max and step
   //
   //
   //
   //
   
   vol = NormalizeDouble(vol / lot_step,0) * lot_step;
   if(vol < lot_min) vol = lot_min;
   if(vol > lot_max) vol = lot_max;

return(vol);
} 

//
//
//
//
//

int BuyMarketCount(string argSymbol, int argMagicNumber)
{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
			OrderSelect(Counter,SELECT_BY_POS);
			if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_BUY)
				{
					OrderCount++;
				}
		}
	return(OrderCount);
}
	
//
//
//
//
//
	
int SellMarketCount(string argSymbol, int argMagicNumber)
{
		int OrderCount;
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
		{
			OrderSelect(Counter,SELECT_BY_POS);
			if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_SELL)
				{
					OrderCount++;
				}
		}
	return(OrderCount);
}  

//-----------------------------------------------------
// Function TrailStop
//-----------------------------------------------------
//
//


void BuyTrailingStop(string argSymbol, int argTrailingStop, int argMinProfit, int argMagicNumber)
	{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);

				// Calculate Max Stop and Min Profit
				double MaxStopLoss = MarketInfo(argSymbol,MODE_BID) - (argTrailingStop * Point* _Point);
				MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit = MarketInfo(argSymbol,MODE_BID) - OrderOpenPrice();
				double MinProfit = argMinProfit * Point* _Point;

				// Modify Stop
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_BUY && CurrentStop < MaxStopLoss && PipsProfit >= MinProfit)
					{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						// Error Handling
						if(Trailed == false)
							{
								int ErrorCode = GetLastError();
								string ErrDesc = ErrorDescription(ErrorCode);

								string ErrAlert = StringConcatenate("Buy Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog = StringConcatenate("Bid: ",MarketInfo(argSymbol,MODE_BID)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
							}
				}			
		}
}
	
//
//
//
//
//	
	
void SellTrailingStop(string argSymbol, int argTrailingStop, int argMinProfit, int argMagicNumber)
	{
		for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
			{
				OrderSelect(Counter,SELECT_BY_POS);

				// Calculate Max Stop and Min Profit
				double MaxStopLoss = MarketInfo(argSymbol,MODE_ASK) + (argTrailingStop * Point* _Point);
				MaxStopLoss = NormalizeDouble(MaxStopLoss,MarketInfo(OrderSymbol(),MODE_DIGITS));
				
				double CurrentStop = NormalizeDouble(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));

				double PipsProfit = OrderOpenPrice() - MarketInfo(argSymbol,MODE_ASK);
				double MinProfit = argMinProfit * Point* _Point;

				// Modify Stop
				if(OrderMagicNumber() == argMagicNumber && OrderSymbol() == argSymbol && OrderType() == OP_SELL && (CurrentStop > MaxStopLoss || CurrentStop == 0) && PipsProfit >= MinProfit)
					{
						bool Trailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);

						// Error Handling
						if(Trailed == false)
							{
								int ErrorCode = GetLastError();
								string ErrDesc = ErrorDescription(ErrorCode);

								string ErrAlert = StringConcatenate("Sell Trailing Stop - Error ",ErrorCode,": ",ErrDesc);
								Alert(ErrAlert);

								string ErrLog = StringConcatenate("Ask: ",MarketInfo(argSymbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",MaxStopLoss);
								Print(ErrLog);
							}
				}			
		}
}

//-----------------------------------------------------
// Function Open Sell Orders
//-----------------------------------------------------
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   double SellStop;
   double SellProfit;
   
   //
   //
   //
   //
   //
        	  
   if  (StopLoss > 0) SellStop  = StopPrice + StopLoss * Point * _Point;  
	else SellStop = 0; 
	
	//
	//
	//
	//
	//
	 
   if (TakeProfit  > 0) SellProfit = SellPrice - TakeProfit * Point * _Point; 
   else SellProfit=0;
   
   //
   //
   //
   //
   //
   
   if(!ECNbroker)
   {
     int sellticket = OrderSend(Symbol(),OP_SELL,MoneyManagement(),SellPrice,Slippage * Point *_Point,SellStop,SellProfit,Expert_Name+" SELL",Magic,0,Red);
     if(sellticket >= 0) 
     {
       if (OrderSelect(sellticket, SELECT_BY_TICKET, MODE_TRADES)) 
       {
 
      		Print("SELL order opened: ", OrderOpenPrice());
            BEvent=0;
            if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid,Digits) + " Open Sell");
   		}
   		else Print("SELL: OrderSelect failed with error #",GetLastError());
      }
      else Print("SELL: OrderSend failed with error #",GetLastError());  
      return(0);
   }
   else 
   {
      sellticket = OrderSend(Symbol(),OP_SELL,MoneyManagement(),SellPrice,Slippage * Point *_Point,0,0,Expert_Name+" SELL",Magic,0,Red);               
      if(sellticket >= 0) 
      {
         if (OrderSelect(sellticket, SELECT_BY_TICKET, MODE_TRADES)) 
         {
   
      		OrderModify(sellticket,OrderOpenPrice(),SellStop,SellProfit,0,Magenta);
      		Print("SELL order opened: ", OrderOpenPrice());
            BEvent=0;
            if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid,Digits) + " Open Sell");
   		}
   		else Print("SELL: ECN OrderSelect failed with error #",GetLastError());
      }
      else Print("SELL: ECN OrderSend failed with error #",GetLastError());
      return(0);
   }	
}

//-----------------------------------------------------
// Function Open Buy Orders
//-----------------------------------------------------
//
//

void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   double BuyStop;
   double BuyProfit;
   
   //
   //
   //
   //
   //
      
   if  (StopLoss > 0) BuyStop  = StopPrice - StopLoss * Point * _Point;   
	else BuyStop = 0;
	
	//
	//
	//
	//
	//
	
   if (TakeProfit  > 0) BuyProfit = BuyPrice + TakeProfit * Point * _Point;
   else BuyProfit=0;  
   
   //
   //
   //
   //
   //
   
	if(!ECNbroker)
	{	 	
     int buyticket = OrderSend(Symbol(),OP_BUY,MoneyManagement(),BuyPrice,Slippage * Point * _Point,BuyStop,BuyProfit,Expert_Name+" BUY",Magic,0,Blue);  
     if(buyticket >= 0) 
     {
       if(OrderSelect(buyticket, SELECT_BY_TICKET, MODE_TRADES)) 
       {
      	 Print("BUY order opened: ", OrderOpenPrice());
          BEvent=0;
          if(SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask,Digits) + " Open Buy");
   	 }
   	 else Print("BUY : OrderSelect failed with error #",GetLastError());
      }
      else Print("BUY : OrderSend failed with error #",GetLastError());
      return(0);
   }
   else 
   {
   	buyticket = OrderSend(Symbol(),OP_BUY,MoneyManagement(),BuyPrice,Slippage * Point * _Point,0,0,Expert_Name+"BUY",Magic,0,Blue);  
      if(buyticket >= 0) 
      {
        if(OrderSelect(buyticket, SELECT_BY_TICKET, MODE_TRADES)) 
        {
            OrderModify(buyticket,OrderOpenPrice(),BuyStop,BuyProfit,0,Aqua);
    
      		Print("BUY order opened: ", OrderOpenPrice());
            BEvent=0;
            if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask,Digits) + " Open Buy");
   	  }
   	 else Print("BUY: ECN OrderSelect failed with error #",GetLastError());
      }
      else Print("BUY: ECN OrderSend failed with error #",GetLastError());
      return(0);
   }   
} 

//
//
//
//
//
//
//-----------------------------------------------------
// Function CloseOrder
//-----------------------------------------------------

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=OrdersTotal(); i>=0; i--)  
   {
   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()      != Symbol()) continue;
         if (OrderMagicNumber() != Magic)    continue;
         {

      if ((mode == 0 || mode == 1) && OrderType() == OP_BUY )  { result = CloseAtMarket(OrderTicket(),OrderLots(),Aqua); break; }
      if ((mode == 0 || mode == 2) && OrderType() == OP_SELL)  { result = CloseAtMarket(OrderTicket(),OrderLots(),Pink); break; }
      }
   }
}

//-----------------------------------------------------
// Function CloseAtMarket
//-----------------------------------------------------
//
//

bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage * Point * _Point,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != Symbol())                       continue;
      if (!StrictNoHedge && OrderMagicNumber() != Magic)   continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL)   return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)    return(false); 
   }      
   return(true);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(8821);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(8822);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(8831);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(8832);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(8841);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(8842);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(8851);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(8861);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(8862);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(8863);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(8864);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(8865);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(8866);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(8867);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(8871);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(8872);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(8873);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(8881);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(8882);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(8883);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(8891);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(8892);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(8893);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(8894);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(8895);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
return(ManualMagic);
}

